/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// audiomsg.h Fri Jun 15 2001
// Description: Audio Message Represents an audio message that is
//							spoken by the player to his peers
//////////////////////////////////////////////////////////////////////

#ifndef _AUDIOMSG_H_
#define _AUDIOMSG_H_

#include "action.h"
#include "servercommand.h"
#include "worldplayer.h"
#include "worldball.h"

#include "saycommand.h"

class AudioMsg : public Action
{
public: 
//	AudioMsg(const char* pcMessage);
	AudioMsg();
	~AudioMsg();
	
	// these two functions will extract the necessary data
	// to create the strings for the server
	bool addPlayer(const WorldPlayer& _wp);
	bool addBall(const WorldBall& _wbBall);
	
	// translate will encapsulate the entire message in ( )
	virtual ServerCommand* translate() const;
	virtual Action* copy() const;
    // logging and debugging facilities
    virtual ostream& ostream_insert(ostream& _out) const;
    virtual ofstream& ofstream_insert(ofstream& _fout) const;
	
	
private:
	char pcMessage[MAX_SAY_MSG_SIZE];
	//the message
	//const char* pcMessage;
};

#endif
