/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// interceptaction.h Fri Jun 29 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _INTERCEPTACTION_H_
#define _INTERCEPTACTION_H_

#include "action.h"
#include "worldmodel.h"

#define MIN_TURN_WINDOW 0.1
#define MAX_TURN_WINDOW PI_8
#define MAX_DASH_POWER 100

class InterceptAction : public Action
{
public: 
	InterceptAction(WorldModel& _wmWorld);
	InterceptAction(WorldModel& _wmWorld, const Angle& _aDirection, double _dIntensity);	
	virtual ~InterceptAction();
	virtual Action* copy() const;
	virtual ServerCommand* translate() const;

	void setDirection(const Angle& _aDirection);
	void setIntensity(double dIntensity);
	
	Angle getDirection() const;
	double getIntensity() const;
    virtual ostream& ostream_insert(ostream& _out) const;
    virtual ofstream& ofstream_insert(ofstream& _fout) const;

    int iBallAge;

    bool operator==(const InterceptAction& rhs) const;
private:
	Angle aDirection;
	double dIntensity;
	static bool fAlreadyTurned;
	mutable char pcCommand[80]; // for logging
	WorldModel& wmWorld;

};

#endif
