//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2000 competition
//
// Copyright (C) 1998, 1999, 2000 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//-*- c++ -*-/////////////////////////////////////////////////////////
//
//  $Id: comm.h,v 1.3 2001/07/13 20:50:33 jmm9gc Exp $
//  $Manager: eri$
// 
// 
//  comm.h - Communication with soccer server
// 
//  original version: Christian Bauer <cebix>, Achim Liese <wiz>
//
//  rebuilt for MRB99, 
//  tuned and cleaned up for MRB2000 by  Erich Kutschinski <eri>
//
//////////////////////////////////////////////////////////////////////


#ifndef _COMM_H_
#define _COMM_H_


#include "constants.h"
// #include "sensor.h"
#include "parser.h"
#include "datastore.h"
// #include "asyncinfo.h"
//#include "audiomgr.h"
#include "debug.h"
#include "lowlevelcomm.h"
// #include "audiomsg.h"

class Comm : public LowLevelComm
{
 public:

  Comm ();    // name of own team
  virtual ~Comm();

  bool isActionNeeded();

//  void say(AudioMsg &msg);
//  bool getNextMsg(AudioMsg &msg);

comm_error init(IdentityData &_idAboutMe,
           const char* hostname,
           int port,
           int reconnectNumber);
  //bool getNextData(SensorData &data);

protected:
  void sendSay        (const char *message);
  // executed in main process, if using FLAGGING; else executed in sighandlers
  virtual void finishAlarm();
  virtual void finishIo(SensorDataStore &_store);

private:
	// functions to check in with the server
  void       generateCheckinMessage(char* outmsg, const IdentityData &_idAboutMe, int reconnectNumber);
  comm_error parseCheckinResponse(IdentityData &_idAboutMe, char* inmsg, int reconnectNumber);
  comm_error checkinAtServer (IdentityData &_idAboutMe, int reconnectNumber);

  // parser to parse serverstring into SensorData
	// NOTE: eventually each sensordata should probably parse itself from a string
	// comm should have a function called parse (maybe pure virtual) to handle the big
	// switch decision for which object to choose
  Parser paParser; // paCharMessage;

  bool hadMessage;
  int  noMessageCount;

};

#endif
