/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// audioworldbehavior.cpp Fri Jul 13 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "audioworldbehavior.h"

AudioWorldBehavior::AudioWorldBehavior(const WorldModel& _wmWorld) : awp(_wmWorld)
{
    iLastTime = UNKNOWN;
}

AudioWorldBehavior::~AudioWorldBehavior()
{
}

bool AudioWorldBehavior::isUseful()
{
  if (!awp.isActiveMode())
    return false;
  
  if(awp.ballTooOld(1)) return false;
  
  if((awp.getTime() > iLastTime+10)) // && awp.myTurn())
    {
      iLastTime = awp.getTime();
      return true;
    }
  
  return false;
}

void AudioWorldBehavior::evaluate(RecommendationList& recList)
{
    Recommendation recFinal;
    recFinal.szBehaviorName = "audioworld";

    AudioMsg amMsg;

    awp.fillMsg(amMsg); // TODO: edit perception

    recFinal.addAction(amMsg);

    recFinal.setGrade(10);

    recList.insert(recFinal);
}
