/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// crossbehavior.cpp Sat Aug 4 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "crossbehavior.h"
#include "kickaction.h"

CrossBehavior::CrossBehavior(const WorldModel &_wmWorld) : perCross(_wmWorld)
{
}

CrossBehavior::~CrossBehavior()
{
}

bool CrossBehavior::isUseful()
{
  return (!perCross.ballTooOld() 
	  && perCross.atBall() 
	  && perCross.inCrossingArea ());
}

void CrossBehavior::evaluate(RecommendationList &recList)
{
  Recommendation recCross;
  KickAction kaKick;
  
  kaKick.setDirection (perCross.angleToKick());
  kaKick.setIntensity(100);
  
  recCross.addAction(kaKick);
  recCross.setGrade (95);
	
  // for debugging only
  recCross.szBehaviorName = "cross";
  recList.insert(recCross);
}
