/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// gotogoalperception.h Tue Jul 3 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _GOTOGOALPERCEPTION_H_
#define _GOTOGOALPERCEPTION_H_

#include "perception.h"

class GoToGoalPerception : public Perception
{
public: 
	GoToGoalPerception(const WorldModel &_wmWorld);
	virtual ~GoToGoalPerception();
	Angle angleToGoal() const;
	Angle angleToKick() const;
	bool atBall() const;
	bool ballMovingFaster();
	bool willPassBall(double _dDashPower = 20.0) const;
	bool ballAged() const;
	bool isBreakAway();
private:
	Vector2d vLastVel;
};

#endif
