/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// interceptballperception.h Tue Jul 3 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _INTERCEPTBALLPERCEPTION_H_
#define _INTERCEPTBALLPERCEPTION_H_

#include "perception.h"

class InterceptBallPerception : public Perception
{
public: 
	InterceptBallPerception(const WorldModel &_wmWorld);
	virtual ~InterceptBallPerception();
	bool atBall(const WorldPlayer &_wpPlayer) const; // within KICK_RANGE
	Angle angleToBall() const; // relPos.getAngle
	int getDashVector(Vector2d &_vDash) const; // mother function
	bool isTooFarFromBall() const; // if too far just run towards it case
	bool isActiveMode() const;
	bool needToIntercept() const; // if you're the goalie & it's in penalty area, etc...
    bool amITwoClosest() const; // am I one of the two closest players to the ball
	bool inDefensiveThird(WorldObject _woObj) const;
	bool ballInPenaltyArea() const;	
	int getWorldAge() const;
	bool sendDashOnly() const;
	
	bool specialSituation() const; // if you need to go to the ball but the enemy is not chasing you down


	
protected:	
	// used when you are not threatened, or to compute threating player's intercept time
	bool intercept(Vector2d &_vInterceptPoint, int &_iTime, const Vector2d& _vInitialPos,
	               const Vector2d& _vInitialVel, double _dAcceleration, int playerDelay) const;
	// used when you are threatened
	Vector2d accelToIntercept(int _iTime) const;
//	int minBallInterceptTime(const WorldPlayer& wpPlayer) const;
	// calls intercept() on ClientPlayer
	Angle accelAngleToIntercept(double _dDashPower) const;	
	bool closestOpponentToBall(WorldPlayer &_wpPlayer) const;
	bool inDefensiveHalf(const WorldObject& _woObj) const;
	bool goalieHasBall() const;
};

#endif
