/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// offensecenterperception.cpp Fri Aug 3 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "offensecenterperception.h"

OffenseCenterPerception::OffenseCenterPerception(const WorldModel &_wmWorld) : Perception(_wmWorld)
{
}

OffenseCenterPerception::~OffenseCenterPerception()
{
}


bool OffenseCenterPerception::amInOffense()
{
  if (wmWorld.getWorldBall().getAge () <= 10
      && (wmWorld.getWorldBall().getAbsPosition().getX() > -10.0))
    {
      return true;
    }
  
  return false;
}

bool OffenseCenterPerception::amClose()
{
  if (norm (wmWorld.getClientPlayer().getAbsPosition() 
	    - Vector2d(0.5 * FIELD_LENGTH - PENALTY_AREA_LENGTH,0.0)) < 3.0)
    {
      return true;
    }
  
  return false;
}


bool OffenseCenterPerception::isActiveMode()
{
  play_mode pmTemp = wmWorld.getPlayMode();	
  if ((pmTemp == PLAY_MODE_PLAY_ON) ||
      (pmTemp == PLAY_MODE_DROP_BALL) ||
      (pmTemp == PLAY_MODE_GOAL_KICK_US) ||
      (pmTemp == PLAY_MODE_FREE_KICK_US) ||		  		
      (pmTemp == PLAY_MODE_GOAL_KICK_THEM) ||		
      (pmTemp == PLAY_MODE_KICK_IN_US) ||		
      (pmTemp == PLAY_MODE_CORNER_KICK_US) 		
      ) {
    return true;
  }
	
  return false;
}
