/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// shootperception.cpp Tue Jul 3 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "shootperception.h"

ShootPerception::ShootPerception(const WorldModel &_wmWorld) : Perception(_wmWorld)
{
}

ShootPerception::~ShootPerception()
{
}

bool ShootPerception::atBall() const
{
  ClientWorldPlayer cwpClientPlayer = wmWorld.getClientPlayer();
  WorldBall wbBall = wmWorld.getWorldBall();
  
  return (dist(cwpClientPlayer, wbBall) < KICKRANGE);
}

bool ShootPerception::atGoal() const
{
  ClientWorldPlayer cwpClientPlayer = wmWorld.getClientPlayer();
  WorldObject woGoal = wmWorld.getOtherGoal();
  
  return (dist(cwpClientPlayer, woGoal) < GOAL_RANGE);	
}

double ShootPerception::haveShot() const
{
  ClientWorldPlayer cwpClientPlayer = wmWorld.getClientPlayer();
  WorldObject woGoal = wmWorld.getOtherGoal();
  // scale the grade from 75 to 100 with a wide 100 region based on proximity to goa
  // look at all the magic numbers :)
  double dShotGrade = 100 * (2.5 * GOAL_RANGE - dist(cwpClientPlayer, woGoal)) / GOAL_RANGE;
  
  if (dShotGrade > 100)
    dShotGrade = 100;
  else if (dShotGrade < 0)
    dShotGrade = 0;

  if (fabs (cwpClientPlayer.getAbsPosition ().getY ()) > 15.0) {
    dShotGrade *= 15.0 / (fabs (cwpClientPlayer.getAbsPosition ().getY ()));
  }
  
  INSPECT ("Shot grade: " << dShotGrade);
  return dShotGrade;	
}

Angle ShootPerception::getShotAngle() const
{
  ClientWorldPlayer cwpClientPlayer = wmWorld.getClientPlayer();
  WorldObject woGoal = wmWorld.getOtherGoal();
  Vector2d vTargetPos;
 
  if (false) { // fabs (cwpClientPlayer.getAbsPosition ().getY ()) > 15.0) {
    vTargetPos = Vector2d (FIELD_LENGTH * 0.5, 0.0);
  } else if (cwpClientPlayer.getAbsPosition ().getY () < 0.0) {
    vTargetPos = Vector2d (FIELD_LENGTH * 0.5, -.45 * GOAL_WIDTH);
  } else {
    vTargetPos = Vector2d (FIELD_LENGTH * 0.5, +.45 * GOAL_WIDTH);
  }

  return relPos (vTargetPos).getAngle();
  
  // Dev messing around
  /*
  ClientWorldPlayer cwpCurrent = wmWorld.getClientPlayer();
  Vector2d vPlayerPos = cwpCurrent.getAbsPosition();
  Vector2d vTopPost(FIELD_LENGTH / 2, -GOAL_WIDTH / 2);
  Vector2d vTopPostRelPlayer = vTopPost - vPlayerPos;
  cout <<"TOP POST:  X = " << FIELD_LENGTH / 2 << " Y = " << -GOAL_WIDTH / 2 <<  endl;
  cout << "Top Post Ang = " << vTopPost.getAngle() << " Player Ang = " << cwpCurrent.getFaceDir() << endl;
  cout << "Top Post Rel Player Ang = " << vTopPostRelPlayer.getAngle() << endl;
  cout <<"PLAYER POS:  X = " << vPlayerPos.getX() << " Y = " << vPlayerPos.getY() << " Ang = " << cwpCurrent.getBodyDir() << endl;
  return (vTopPostRelPlayer.getAngle() - cwpCurrent.getBodyDir());
  */
}

