/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// stayonfieldbehavior.cpp Thu Jul 12 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "stayonfieldbehavior.h"

StayOnFieldBehavior::StayOnFieldBehavior(const WorldModel& _wmWorld) : perStayOnField(_wmWorld)
{
}

StayOnFieldBehavior::~StayOnFieldBehavior()
{
}

bool StayOnFieldBehavior::isUseful()
{
    if(!perStayOnField.isActiveMode()) return false;
    
    return true; //perStayOnField.amICloseToSide(); // if off the field, this will definately be true
}


void StayOnFieldBehavior::evaluate(RecommendationList& recList)
{
    Recommendation recFinal;
    recFinal.szBehaviorName = "stayonfield";
/*
    // Don't want to screw up the player with the ball
    if(perStayOnField.amIClosestToBall())
    {
        recFinal.setGrade(0);
        return recFinal;
    }
*/
    if(!perStayOnField.amIOnField()) // off the field -> run home
//    if(perStayOnField.amICloseToSide()) // off the field -> run home
    {
        recFinal.setGrade(100);
    }
    else // on field, but near the side -> scale a grade
    {
        recFinal.setGrade( perStayOnField.computeGrade() );
    }

		//recFinal.setGrade(100);
    RunAction raRun;
    raRun.setDirection(perStayOnField.getHomeDir());
    raRun.setIntensity(50);

    recFinal.addAction(raRun);
    recList.insert(recFinal);
}
