/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// physicaldata.cpp Wed Jun 13 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "physicaldata.h"
#include "clientworldplayer.h"

PhysicalData::PhysicalData()
{
}

PhysicalData::PhysicalData(int _time) : SensorData(_time)
{
}

PhysicalData::~PhysicalData()
{
}

WorldModel& PhysicalData::worldmodel_insert(WorldModel &_wmWorld) const
{
	// TODO: find a more clean way than pulling out the client player
	//			 to make changes.  This breaks Demeter's Law
	
	// WARNING: this is also set with VisualData insert, possible conflict?
	// setTime must be set fist to keep age in order
	_wmWorld.setTime(time);	

	ClientWorldPlayer* pwpClient = _wmWorld.modifyClientPlayer();
	
	pwpClient->setDashCount(dash_count);
	pwpClient->setTurnCount(turn_count);
	pwpClient->setKickCount(kick_count);
	pwpClient->setTurnNeckCount(turn_neck_count);
	pwpClient->setSayCount(say_count);
	
	pwpClient->setEffort(effort);
	pwpClient->setStamina(stamina);
	pwpClient->setHeadDir(head_angle);
	pwpClient->setVelocity(speed, speed_angle + pwpClient->getFaceDir());
	pwpClient->setViewQuality(my_view_quality);
	pwpClient->setViewWidth(my_view_width);

	return _wmWorld;
}

ostream& PhysicalData::ostream_insert(ostream &sout) const
{
  sout << "view_width:      " << my_view_width << endl;
  sout << "view_quality:    " << my_view_quality << endl;
  sout << "stamina:         " << stamina << endl;
  sout << "effort:          " << effort << endl;
  sout << "speed:           " << speed << endl;
  sout << "speed_angle:     " << speed_angle << endl;
  sout << "head_angle:      " << head_angle << endl;
  sout << "kick_count:      " << kick_count << endl;
  sout << "dash_count:      " << dash_count << endl;
  sout << "turn_count:      " << turn_count << endl;
  sout << "say_count:       " << say_count << endl;
  sout << "turn_neck_count: " << turn_neck_count << endl;

  return sout;
}
