/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// clientworldplayer.cpp Thu Jun 28 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "clientworldplayer.h"

ClientWorldPlayer::ClientWorldPlayer() : WorldPlayer()
{
	setDashCount(UNKNOWN);
	setKickCount(UNKNOWN);
	setSayCount(UNKNOWN);
	setTurnCount(UNKNOWN);
	setTurnNeckCount(UNKNOWN);
	setPlayingSide(SIDE_UNKNOWN);
	setViewWidth(VIEW_WIDTH_UNKNOWN);
	setViewQuality(VIEW_QUALITY_UNKNOWN);
	// the client player is always getting information about himself
	setAge(0);
	setKnown();
}

ClientWorldPlayer::~ClientWorldPlayer()
{
}

void ClientWorldPlayer::setFaceDir(Angle _aFaceDir)
{
	aFaceDir = _aFaceDir;
}

Angle ClientWorldPlayer::getFaceDir() const
{
	return aFaceDir;
}

Angle ClientWorldPlayer::getBodyDir() const
{
  return (aFaceDir - getHeadDir());
}

playing_side ClientWorldPlayer::getPlayingSide() const
{
	return plsSide;
}

void ClientWorldPlayer::setPlayingSide(playing_side _plsSide)
{
	plsSide = _plsSide;
}

void ClientWorldPlayer::setKickCount(int _iKickCount)
{
	// TODO: add error checking to ensure that server
	//			 matches local information
	iKickCount = _iKickCount;
}


int ClientWorldPlayer::getKickCount() const
{
	return iKickCount;
}

void ClientWorldPlayer::setDashCount(int _iDashCount)
{
	// TODO: add error checking to ensure that server
	//			 matches local information
	iDashCount = _iDashCount;
}


int ClientWorldPlayer::getDashCount() const
{
	return iDashCount;
}

void ClientWorldPlayer::setSayCount(int _iSayCount)
{
	// TODO: add error checking to ensure that server
	//			 matches local information
	iSayCount = _iSayCount;
}


int ClientWorldPlayer::getSayCount() const
{
	return iSayCount;
}

void ClientWorldPlayer::setTurnCount(int _iTurnCount)
{
	// TODO: add error checking to ensure that server
	//			 matches local information
	iTurnCount = _iTurnCount;
}


int ClientWorldPlayer::getTurnCount() const
{
	return iTurnCount;
}

void ClientWorldPlayer::setTurnNeckCount(int _iTurnNeckCount)
{
	// TODO: add error checking to ensure that server
	//			 matches local information
	iTurnNeckCount = _iTurnNeckCount;
}


int ClientWorldPlayer::getTurnNeckCount() const
{
	return iTurnNeckCount;
}

void ClientWorldPlayer::setViewQuality(view_quality _vqViewQuality)
{
  vqViewQuality = _vqViewQuality;
}

view_quality ClientWorldPlayer::getViewQuality() const
{
  return vqViewQuality;
}

void ClientWorldPlayer::setViewWidth(view_width _vwViewWidth)
{
  vwViewWidth = _vwViewWidth;
}

view_width ClientWorldPlayer::getViewWidth() const
{
  return vwViewWidth;
}

ofstream& ClientWorldPlayer::ofstream_insert(ofstream& _out)
{
    _out << "  <clientworldplayer team=\"" << getTeam() << "\" number=\"" << getNumber()
         << "\" headdir=\"" << getHeadDir() << "\" bodydir=\"" << getBodyDir()
         << "\" viewquality=\"" << getViewQuality() << "\" viewwidth=\"" << getViewWidth() << "\">" << endl;

    WorldMovableObject::ofstream_insert(_out);

    _out << "  </clientworldplayer>" << endl;


    return _out;
}
