/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// coachworldmodel.h Thu Jun 28 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef COACHWORLDMODEL_H
#define COACHWORLDMODEL_H

#include "baseworldmodel.h"

class CoachWorldModel : public BaseWorldModel
{
public:
	CoachWorldModel();
	virtual ~CoachWorldModel();

  void setOurGoal(const ExactGoal &_egOurGoal); // coach facility	
	void setOtherGoal(const ExactGoal &_egOtherGoal); // coach facility
  void updateWorldBall(const ExactObject &_eoBall); // coach facility

 	// updatePlayer(ExactPlayer) adds information
	// obtained by the coach client (I am the coach client)
	void updatePlayer(const ExactPlayer& _ePlayer); // coach facility
	
// 	ofstream& ofstream_insert(ofstream& _out);
// 	ifstream& ifstream_extract(ifstream& _in);
	

};

// WARNING: this function dumps binary data!!!
ofstream& operator<<(ofstream& _out, CoachWorldModel &_cwmWorld);
ifstream& operator>>(ifstream& _in, CoachWorldModel &_cwmWorld);

#endif
